# HG changeset patch
# User Oliver Heimlich <oheim@posteo.de>
# Date 1446676031 -3600
#      Wed Nov 04 23:27:11 2015 +0100
# Node ID 43a14f7a2cc2bfe347f4b2c4a2de05abecaab524
# Parent  6ed59fc758104b8c933fecf074c1221ecdbfcd00
Show icons and short package description on package overview page

pkg-icon.png: New icon for link to package site
octave-forge.css: Added/modified style for new package overview page
packages.php: Added credits to third-party work for the package icons
javascript.js: Removed (un)fold functions for old package overview page

bim.png: From Octave Wiki http://wiki.octave.org/File:Fiume_sol_pdesurf.png
cgi.png: Own work with cliparts from LibreOffice
communications.png: From Wikimedia Commons (GFDL, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Hamming_distance_3_bit_binary_example.svg
control.png: From Octave Wiki http://wiki.octave.org/File:Inverted_pendulum_new.png
data-smoothing.png From function reference for “regdatasmooth”
database.png: Own work with cliparts from LibreOffice and the PostreSQL logo
dataframe.png: From Octave Wiki http://wiki.octave.org/Dataframe_package
dicom.png: From Wikimedia Commons https://commons.wikimedia.org/wiki/File:Knie_mr.jpg
divand.png: From http://modb.oce.ulg.ac.be/mediawiki/index.php/File:Divand_realistic_example.png
doctest.png: Own work with cliparts from LibreOffice and Wikipedia Commons (LGPL) https://commons.wikimedia.org/wiki/File:Crystal_Project_bug.png
econometrics.png: From Wikimedia Commons (GFDL, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Okuns_law_differences_1948_to_mid_2011.png
fem-fenics.png: From Octave Wiki http://wiki.octave.org/File:HyperElasticity.png
financial.png: Own work with cliparts from LibreOffice
fits.png: From Wikimedia Commons (GPL2+) https://commons.wikimedia.org/wiki/File:SAOImage-DS9.png
fpl.png: From function reference for “pdesurf”
fuzzy-logic-toolkit.png: From function “heart_disease_demo_1”
ga.png: From Wikimedia Commons (GFDL, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Computational.science.Genetic.algorithm.Crossover.Two.Point.svg
general.png: From Wikimedia Commons (LGPL3, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Gnome-applications-other.svg
generate_html.png: Remixed some (LGPL3, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/GNOME_Desktop_icons
geometry.png: From Wikimedia Commons (public domain) https://commons.wikimedia.org/wiki/File:Teorema_de_desargues.svg
image.png: From function reference for “imtransform”
image-acquisition.png: From function reference for “getsnapshot”
instrument-control.png: From Wikimedia Commons (public domain) https://commons.wikimedia.org/wiki/File:9_pin_d-sub_connector_male_closeup.jpg
interval.png: From function reference for “@infsup/plot”
io.png: From Wikimedia Commons (LGPL2.1+) https://commons.wikimedia.org/wiki/File:Crystal_Clear_mimetype_spreadsheet.png
level-set.png: From function reference for “ls_setxor”
linear-algebra.png: From Wikimedia Commons (GFDL, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Matrix_pattern_qtl3.svg
lssa.png: From Journal of Statistical Software (CC-BY 3.0) http://www.jstatsoft.org/article/view/v011i02
ltfat.png: From function reference for “demo_phaseret”
mapping.png: From Wikimedia Commons (public domain) https://commons.wikimedia.org/wiki/File:Map_coordinate_system.gif
mechanics.png: From function reference for “mdsim”
miscellaneous.png: From Wikimedia Commons (LGPL3, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Gnome-preferences-other.svg
missing.png: Based on Wikimedia Commons (LGPL3, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Gnome-emblem-package.svg
mpi.png: From Wikimedia Commons (public domain) https://commons.wikimedia.org/wiki/File:NetworkTopology-FullyConnected.svg
msh.png: From OctConf 2015 slides
mvn.png: From Wikimedia Commons (GFDL) https://commons.wikimedia.org/wiki/File:NormalVert2d.png
nan.png: Own work
ncarray.png: From http://www.unidata.ucar.edu/software/netcdf/
netcdf.png: From Wikimedia Commons (public domain) https://commons.wikimedia.org/wiki/File:Image_annotations.jpg
nurbs.png: From OctConf 2015 slides
ocs.png: From Octave Wiki http://wiki.octave.org/File:AND_BW.png
octclip.png: From Function reference for “oc_polybool”
octproj.png: From Wikimedia Commons (public domain) https://commons.wikimedia.org/wiki/File:201globe.svg
odepkg.png: From Wikimedia Commons (public domain) https://commons.wikimedia.org/wiki/File:Slope_Field_4b.png
optics.png: From Function reference for “zernike_cartesian”
optim.png: Own work (Rastrigin function)
optiminterp.png: From Wikimedia Commons (GFDL, CC-BY 3.0) https://commons.wikimedia.org/wiki/File:Sst_dayly.png
parallel.png: Own work
quaternion.png: Own work
queueing.png: From Wikimedia Commons (GFDL, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Simple_markov_chain.svg
signal.png: From Wikimedia Commons (CC0) https://commons.wikimedia.org/wiki/File:Aliasing_between_a_positive_and_a_negative_frequency.png
sockets.png: Own work
sparsersb.png: From librsb website (LGPL3+) http://librsb.sourceforge.net/
specfun.png: From Wikimedia Commons (public domain) https://commons.wikimedia.org/wiki/File:ZetaFunction.png
splines.png: From Wikimedia Commons https://commons.wikimedia.org/wiki/File:Spline_interpolation.svg
statistics.png: From Function reference for “boxplot”
stk.png: From project website https://sourceforge.net/projects/kriging/
string.png: Own work
struct.png: From Wikimedia Commons (GFDL, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:ER_Diagram_MMORPG.png
symbolic.png: Own work
tisean.png: From Function reference for “c2g”
tsa.png: From “tsademo”
vrml.png: From Function demo for “vmesh”
windows.png: From Wikimedia Commons (GFDL, CC-BY-SA 3.0) https://commons.wikimedia.org/wiki/File:Freilichtmuseum_Josef_Stetschnigs_Gemischtwarenhandlung_14082007_01.jpg

diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/javascript.js
--- a/htdocs/javascript.js	Thu Oct 29 13:41:27 2015 +0000
+++ b/htdocs/javascript.js	Wed Nov 04 23:27:11 2015 +0100
@@ -57,23 +57,6 @@
     }
 }
 
-function unfold(id)
-{
-    if (document.getElementById(id+"_detailed").style.display == "none") {
-        document.getElementById(id+"_detailed").style.display = "block";
-        document.getElementById(id+"_im").src ="hide.png"
-    } else {
-        document.getElementById(id+"_detailed").style.display = "none";
-        document.getElementById(id+"_im").src ="show.png"
-    }
-}
-
-function fold(id)
-{
-    document.getElementById(id+"_detailed").style.display = "none";
-    document.getElementById(id).style.display = "block";
-}
-
 function show_left_menu ()
 {
   document.getElementById ("left-menu").style.display = "block";
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/octave-forge.css
--- a/htdocs/octave-forge.css	Thu Oct 29 13:41:27 2015 +0000
+++ b/htdocs/octave-forge.css	Wed Nov 04 23:27:11 2015 +0100
@@ -329,14 +329,6 @@
   color: black;
 }
 
-a.package_link {
-  background-color: inherit;
-  color: black;
-  font-weight: bold;
-  font-size: 80%;
-  text-decoration: none;
-}
-
 a.package_head_link {
   background-color: inherit;
   color: black;
@@ -611,3 +603,71 @@
   font-weight: bold;
 }
 
+DIV.package_display {
+    position: relative;
+    display: inline-block;
+    vertical-align: top;
+    margin-right: 2em;
+    margin-bottom: 1em;
+    width: 23em;
+    padding-left: 108px;
+    min-height: 100px;
+    text-decoration: none;
+}
+
+DIV.package_display > * {
+    padding-left: .8em;
+}
+
+DIV.package_display IMG {
+    display: block;
+    position: absolute;
+    padding: 0;
+    left: 0;
+    top: 0;
+    width: 100px; height: 100px;
+    margin-left: 0;
+    margin-right: 1em;
+}
+
+DIV.package_display H3.package_name {
+    border: none;
+    margin-top: 0;
+    margin-bottom: .5em;
+    background-color: #D3D7CF;
+
+    -webkit-transition: all .2s ease-out 0s;
+    -moz-transition: all .2s ease-out 0s;
+    -ms-transition: all .2s ease-out 0s;
+    -o-transition: all .2s ease-out 0s;
+    transition: all .2s ease-out 0s;    
+}
+
+DIV.package_display:hover H3.package_name {
+    background-color: #729FCF;
+}
+
+DIV.package_display P {
+    margin-top: 0;
+    margin-bottom: 0;
+}
+
+DIV.package_display A {
+    color: black;
+    font-weight: bold;
+    font-size: 80%;
+    display: inline-block;
+    text-decoration: none;
+    line-height: 22px;
+    padding: .5em 1.5em .5em 26px;
+    min-height: 22px;
+    background-repeat: no-repeat;
+    background-position: left center;
+}
+
+DIV.package_display A.package_link {
+    background-image: url("pkg-page.png");
+}
+DIV.package_display A.download_link {
+    background-image: url("download.png");
+}
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/packages.php
--- a/htdocs/packages.php	Thu Oct 29 13:41:27 2015 +0000
+++ b/htdocs/packages.php	Wed Nov 04 23:27:11 2015 +0100
@@ -56,14 +56,28 @@
 <p>These packages are meant for current versions of Octave. See the <a href="#unmaintained">unmaintained</a>
 section for information on older versions.</p>
 
+<!-- Revert width: 70% and margin of parent container #content -->
+<div style="width:142%; margin-left: -6em;">
+<!-- Restore margin of #content -->
+<div style="margin-left: 6em; margin-right: 4em;">
 <?php
   include "pkg_status.php";
   foreach ($maintained as $pkg_name)
     {
+      $fname = "pkg_icon/" . $pkg_name . ".png";
+      if (! file_exists ($fname))
+        $fname = "pkg_icon/missing.png";
+      echo '<div class="package_display">';
+      echo '<img src="' . htmlentities ($fname) . '" />';
+      
       $fname = $pkg_name . "/short_package_description";
       echo (file_get_contents ($fname));
+      
+      echo '</div>';
     }
 ?>
+</div>
+</div>
 
 <h2><a id="unmaintained">Renamed or moved packages</a></h2>
 <p>Some packages have been renamed or merged over time. When this
@@ -108,6 +122,35 @@
   echo ("</ul>");
 ?>
 
+<h2>Credits for artistic work used on this site</h2>
+<p>Above package icons have partly been created from third-party work. Respective authors are:
+    communications / <a href="https://commons.wikimedia.org/wiki/File:Hamming_distance_3_bit_binary_example.svg">Colin M.L. Burnett (GFDL, CC-BY-SA 3.0)</a>,
+    dicom / <a href="https://commons.wikimedia.org/wiki/File:Knie_mr.jpg">Shizhao (GFDL, CC-BY-SA 3.0)</a>,
+    doctest / <a href="https://commons.wikimedia.org/wiki/File:Crystal_Project_bug.png">Everaldo Coelho (LGPL 2.1)</a>,
+    econometrics / <a href="https://commons.wikimedia.org/wiki/File:Okuns_law_differences_1948_to_mid_2011.png">Bkwillwm (GFDL, CC-BY-SA 3.0)</a>,
+    fits / <a href="https://commons.wikimedia.org/wiki/File:SAOImage-DS9.png">G&uuml;rkan Seng&uuml;n (GPL2+)</a>,
+    ga / <a href="https://commons.wikimedia.org/wiki/File:Computational.science.Genetic.algorithm.Crossover.Two.Point.svg">Yearofthedragon (GFDL, CC-BY-SA 3.0)</a>,
+    geometry / <a href="https://commons.wikimedia.org/wiki/File:Teorema_de_desargues.svg">Jtico (public domain)</a>,
+    instrument-control / <a href="https://commons.wikimedia.org/wiki/File:9_pin_d-sub_connector_male_closeup.jpg">Mike1024 (public domain)</a>,
+    linear-algebra / <a href="https://commons.wikimedia.org/wiki/File:Matrix_pattern_qtl3.svg">Quartl (GFDL, CC-BY-SA 3.0)</a>,
+    lssa / <a href="http://www.jstatsoft.org/article/view/v011i02">Adolf Mathias, Florian Grond, Ramon Guardans, Detlef Seese, Miguel Canela, Hans H. Diebner (CC-BY 3.0)</a>,
+    mapping / <a href="https://commons.wikimedia.org/wiki/File:Map_coordinate_system.gif">National Atlas of the United States (public domain)</a>,
+    mpi / <a href="https://commons.wikimedia.org/wiki/File:NetworkTopology-FullyConnected.svg">Foobaz (public domain)</a>,
+    mvn / <a href="https://commons.wikimedia.org/wiki/File:NormalVert2d.png">Thomas Steiner (GFDL)</a>,
+    ncarray / <a href="http://www.unidata.ucar.edu/software/netcdf/docs/copyright.html">University Corporation for Atmospheric Research/Unidata (NetCDF license)</a>,
+    netcdf / <a href="https://commons.wikimedia.org/wiki/File:Image_annotations.jpg">UCRL (public domain)</a>,
+    octproj / <a href="https://commons.wikimedia.org/wiki/File:201globe.svg">Peter Mercator (public domain)</a>,
+    odepkg / <a href="https://commons.wikimedia.org/wiki/File:Slope_Field_4b.png">jjbeard (public domain)</a>,
+    optiminterp / <a href="https://commons.wikimedia.org/wiki/File:Sst_dayly.png">Nikolay Koldunov (GFDL, CC-BY 3.0)</a>,
+    queueing / <a href="https://commons.wikimedia.org/wiki/File:Simple_markov_chain.svg">Chrislb (GFDL, CC-BY-SA 2.5)</a>,
+    signal / <a href="https://commons.wikimedia.org/wiki/File:Aliasing_between_a_positive_and_a_negative_frequency.png">Bob K (CC0)</a>,
+    sparsersb / <a href="http://librsb.sourceforge.net/">Michele Martone (LGPL3+)</a>,
+    specfun / <a href="https://commons.wikimedia.org/wiki/File:ZetaFunction.png">Gaussianer (public domain)</a>,
+    splines / <a href="https://commons.wikimedia.org/wiki/File:Spline_interpolation.svg">Tam (public domain)</a>,
+    struct / <a href="https://commons.wikimedia.org/wiki/File:ER_Diagram_MMORPG.png">Matthew Tardiff (GFDL, CC-BY-SA 3.0)</a>,
+    windows / <a href="https://commons.wikimedia.org/wiki/File:Freilichtmuseum_Josef_Stetschnigs_Gemischtwarenhandlung_14082007_01.jpg">Johann Jaritz (GFDL, CC-BY-SA 3.0)</a>.
+</p>
+
 <div id="sf_logo">
   <a href="http://sourceforge.net"><img src="http://sourceforge.net/sflogo.php?group_id=2888&amp;type=1"
      width="88" height="31" style="border: 0;" alt="SourceForge.net Logo"/></a>
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg-page.png
Binary file htdocs/pkg-page.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/bim.png
Binary file htdocs/pkg_icon/bim.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/cgi.png
Binary file htdocs/pkg_icon/cgi.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/communications.png
Binary file htdocs/pkg_icon/communications.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/control.png
Binary file htdocs/pkg_icon/control.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/data-smoothing.png
Binary file htdocs/pkg_icon/data-smoothing.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/database.png
Binary file htdocs/pkg_icon/database.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/dataframe.png
Binary file htdocs/pkg_icon/dataframe.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/dicom.png
Binary file htdocs/pkg_icon/dicom.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/divand.png
Binary file htdocs/pkg_icon/divand.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/doctest.png
Binary file htdocs/pkg_icon/doctest.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/econometrics.png
Binary file htdocs/pkg_icon/econometrics.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/fem-fenics.png
Binary file htdocs/pkg_icon/fem-fenics.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/financial.png
Binary file htdocs/pkg_icon/financial.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/fits.png
Binary file htdocs/pkg_icon/fits.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/fpl.png
Binary file htdocs/pkg_icon/fpl.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/fuzzy-logic-toolkit.png
Binary file htdocs/pkg_icon/fuzzy-logic-toolkit.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/ga.png
Binary file htdocs/pkg_icon/ga.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/general.png
Binary file htdocs/pkg_icon/general.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/generate_html.png
Binary file htdocs/pkg_icon/generate_html.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/geometry.png
Binary file htdocs/pkg_icon/geometry.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/image-acquisition.png
Binary file htdocs/pkg_icon/image-acquisition.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/image.png
Binary file htdocs/pkg_icon/image.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/instrument-control.png
Binary file htdocs/pkg_icon/instrument-control.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/interval.png
Binary file htdocs/pkg_icon/interval.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/io.png
Binary file htdocs/pkg_icon/io.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/level-set.png
Binary file htdocs/pkg_icon/level-set.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/linear-algebra.png
Binary file htdocs/pkg_icon/linear-algebra.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/lssa.png
Binary file htdocs/pkg_icon/lssa.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/ltfat.png
Binary file htdocs/pkg_icon/ltfat.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/mapping.png
Binary file htdocs/pkg_icon/mapping.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/mechanics.png
Binary file htdocs/pkg_icon/mechanics.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/miscellaneous.png
Binary file htdocs/pkg_icon/miscellaneous.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/missing.png
Binary file htdocs/pkg_icon/missing.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/mpi.png
Binary file htdocs/pkg_icon/mpi.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/msh.png
Binary file htdocs/pkg_icon/msh.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/mvn.png
Binary file htdocs/pkg_icon/mvn.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/nan.png
Binary file htdocs/pkg_icon/nan.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/ncarray.png
Binary file htdocs/pkg_icon/ncarray.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/netcdf.png
Binary file htdocs/pkg_icon/netcdf.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/nurbs.png
Binary file htdocs/pkg_icon/nurbs.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/ocs.png
Binary file htdocs/pkg_icon/ocs.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/octclip.png
Binary file htdocs/pkg_icon/octclip.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/octproj.png
Binary file htdocs/pkg_icon/octproj.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/odepkg.png
Binary file htdocs/pkg_icon/odepkg.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/optics.png
Binary file htdocs/pkg_icon/optics.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/optim.png
Binary file htdocs/pkg_icon/optim.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/optiminterp.png
Binary file htdocs/pkg_icon/optiminterp.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/parallel.png
Binary file htdocs/pkg_icon/parallel.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/quaternion.png
Binary file htdocs/pkg_icon/quaternion.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/queueing.png
Binary file htdocs/pkg_icon/queueing.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/signal.png
Binary file htdocs/pkg_icon/signal.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/sockets.png
Binary file htdocs/pkg_icon/sockets.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/sparsersb.png
Binary file htdocs/pkg_icon/sparsersb.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/specfun.png
Binary file htdocs/pkg_icon/specfun.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/splines.png
Binary file htdocs/pkg_icon/splines.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/statistics.png
Binary file htdocs/pkg_icon/statistics.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/stk.png
Binary file htdocs/pkg_icon/stk.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/strings.png
Binary file htdocs/pkg_icon/strings.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/struct.png
Binary file htdocs/pkg_icon/struct.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/symbolic.png
Binary file htdocs/pkg_icon/symbolic.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/tisean.png
Binary file htdocs/pkg_icon/tisean.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/tsa.png
Binary file htdocs/pkg_icon/tsa.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/vrml.png
Binary file htdocs/pkg_icon/vrml.png has changed
diff -r 6ed59fc75810 -r 43a14f7a2cc2 htdocs/pkg_icon/windows.png
Binary file htdocs/pkg_icon/windows.png has changed